%
%  Tema II : TECNICAS DE DISCRETIZACION
%
%  Solucion de una PDE de segundo orden en 2D mediante Residuos ponderados
%  usando funciones de prueba globales y pesos del tipo Galerkin
%  Las integrales se resuelven en forma simbolica
%

Np=10;
% Dominio a resolver
x  = (0:Np)'/Np;
x  = 6*x-3;
y  = (0:Np)'/Np;
y  = 4*y-2;
nn    = length(x);

[x,y]=meshgrid(x,y);

% Funciones de prueba
% Esta definicion numerica se requiere para armar la solucion
% numerica y graficarla
M       = 5; 
N1      = (4-y.^2);
N2      = (4-y.^2).*(x.^2);
N3      = (4-y.^2).*(y.^2);
N4      = (4-y.^2).*(x.^2).*(y.^2);
N5      = (4-y.^2).*(x.^4);
N       = [m2v(N1),m2v(N2),m2v(N3),m2v(N4),m2v(N5)];

% Integracion simbolica
K=zeros(M,M);
f=zeros(M,1);

% Definicion simbolica de las funciones de prueba
Ns1 = '(4-y^2)';
Ns2 = '(4-y^2)*(x^2)';
Ns3 = '(4-y^2)*(y^2)';
Ns4 = '(4-y^2)*(x^2)*(y^2)';
Ns5 = '(4-y^2)*(x^4)';

% Calculo de las derivadas en forma simbolica y armado de los integrandos
for k=1:M,
  eval(['Ns' num2str(k) '= sym(1,1,Ns' num2str(k) ');'])
  eval(['dN' num2str(k) 'dx = diff(diff(Ns' num2str(k) ',''x''),''x'');']);
  eval(['dN' num2str(k) 'dy = diff(diff(Ns' num2str(k) ',''y''),''y'');']);
  eval(['Nsbp' num2str(k) ' = subs(Ns' num2str(k) ',''3'',''x'');']);
  eval(['Nsbm' num2str(k) ' = subs(Ns' num2str(k) ',''-3'',''x'');']);
end

% Integracion simbolica y asignacion numerica a la matriz y el vector
% miembro derecho
K=zeros(M,M);
f=zeros(M,1);
for l=1:M,
 for m=1:M,
   eval(['Ix = symmul(Ns' num2str(l) ',dN' num2str(m) 'dx);']);
   eval(['Iy = symmul(Ns' num2str(l) ',dN' num2str(m) 'dy);']);
   eval(['Ix = int(int(Ix,''y'',-2,2),''x'',-3,3);']);
   eval(['Iy = int(int(Iy,''y'',-2,2),''x'',-3,3);']);
   Ixy = symadd(Ix,Iy);
   K(l,m) = numeric(Ixy);
   eval(['Ix = symmul(Nsbp' num2str(l) ',Nsbp' num2str(m) ');']);
   eval(['Ix = int(Ix,''y'',-2,2);']);
   K(l,m) = K(l,m)+numeric(Ix);
   eval(['Ix = symmul(Nsbm' num2str(l) ',Nsbm' num2str(m) ');']);
   eval(['Ix = int(Ix,''y'',-2,2);']);
   K(l,m) = K(l,m)+numeric(Ix);
 end
   eval(['Ix = int(int(Ns' num2str(l) ',''y'',-2,2),''x'',-3,3);']);
   f(l) = - 2*numeric(Ix);
end

% Resolucion numerica del sistema de ecuaciones
a  = K\f;

% Armado de la solucion aproximada
psi = 0;
phi_n = psi;
for m=1:M,
  phi_n = phi_n + a(m)*N(:,m);
end  
phi_n = v2m(phi_n,Np+1);

% Graficacion de la aproximacion
figure(1);clg;mesh(x,y,phi_n);
tau_max = max2(abs(phi_n));
stri = [' max(|tau|) = ' num2str(tau_max) ];
figure(1);title(stri)

